



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>2-SAT 及 一点习题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">2-SAT 及 一点习题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 22:44:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天简单学习了一下2-SAT。现在简单地总结一下。至于定义之类的就不写了，这里就写写做法，以防以后忘记。</p>
<h2>构图</h2>
<p>每个值a，拆为两个点，一个表示a，一个表示^a（非a）。每个点我们可以<strong>看成是一个命题</strong>（这是我的理解）。</p>
<p>图中如果有一条边有X连向Y，表示如果X为真，那么可以推出Y为真。</p>
<p>注意，这里的<strong>图是有对称性的</strong>，这样下面的算法正确性才成立。举个例子，如果a连向b，那么必然有^b连向^a；如果^a连向b，那么必然有^b连向a。</p>
<h2>算法</h2>
<p>构好图后我们对其使用<em>强连通分量</em>算法。接着我们就可以得到一个有向无环图了，注意，这里的有向无环图依然满足对称性，这个证明比较简单。</p>
<p>然后我们还需要一个拓扑序，这个是强连通分量是自带的一个结果（根据染色的次序就可以判断）。</p>
<blockquote><p>那么对于每个布尔变量x，让：<br />
x所在的强连通分量的拓扑序在^x所在的强连通分量的拓扑序之后\(\Leftrightarrow\)x为真。</p></blockquote>
<p>当然，如果存在x和^x在一个强连通分量里面，说明无解。否则按照上面的构造是可以得到一组解的。</p>
<h2>正确性</h2>
<p>一开始看到这样做，我是持有怀疑态度的，主要是下面两个情况，我想，把这些分析清楚之后，正确性就显而易见了。</p>
<hr />
<p>情况一：x为真，y为假，但x和y是在同一个强连通分量p里面。</p>
<p>那么^x和^y也在同一个强连通分量q里面。</p>
<p>x为真，p的拓扑序在q的后面。</p>
<p>y为假，p的拓扑序在q的前面。</p>
<p>矛盾。</p>
<hr />
<p>情况二：x为真，^x为假，y为假，^y为真，存在一条边由x连向y。</p>
<p>根据上面的情况一，这里我们可以把x看作x所在的强连通分量。</p>
<p>x为真，^x为假，x在^x的后面。</p>
<p>存在一条边由x连向y，y在x的后面。</p>
<p>y为假，^y为真，^y在y的后面。</p>
<p>这样我们得到了它们的拓扑序^x,x,y,^y。但是，</p>
<p>存在一条边由^y连向^x，^x在^y的后面。</p>
<p>矛盾。</p>
<h2>字典序</h2>
<p>利用贪心的思想，每次从最高位开始确定。</p>
<p>如果我们要使x为真，那么就是加一条由^x向x的边，如果行不通，就会使得x和^x在同一个强连通分量里面。所以，我们只需判断加了这条边后有没有一条从x到^x的路径，如果有就不可以让x为真。</p>
<p>所以我们要在一开始时处理出每两两点之间的连通性（\(O(nm)\)），逐一判断真假。使x为真，就加一条由^x向x的边，同理，使x为假就由x连向^x，然后继续维护连通性（\(O(n^2)\)）。</p>
<p>事实上，我们并不需要继续维护图的连通性，也就是不加上那些边，不妨把这些边称为<strong>没用上的边</strong>。试想，如果在后面，需判断没有一条从x到^x的路径，如果需经过一些<strong>没用上的边</strong>，不妨设其中一条是由u连向v（这里注意u,v一对点），根据对称性可以知道有这样一条回路：x,u,v,^x。所以只需逐一能不能用上这些<strong>没用上的边</strong>（\(O(n)\)）。</p>
<p>这样我们总的复杂度就是\(O(nm+n^2)\)。</p>
<p>这里可能会有些题目使用上述方法过不了，我们可以沿着上面的思路，写一个暴力，虽然最坏情况下依然是\(O(nm)\)，但一些简单的剪枝可以使实际运行快得飞起来。</p>
<h2>习题</h2>
<p><a href="http://codeforces.com/problemset/problem/538/H" rel="external nofollow noreferrer">CF 538H</a></p>
<p>这里有个神奇的解法，如果我们要满足一些数量关系，比如说是限制x的大小的，可以采用这样一个技巧。我们新建一些点，点i表示\(x \leq i\)，那么点i的反面就是\(x &gt; i\)。<br />
如果x的大小范围比较大，那么就运用离散化的类似思想，这题的话，我们要选出最终答案可能取的所有值就可以了。</p>
<p>吐槽：我发现我越来越水了，debug了两天。。。。还有，为什么我tarjan的手写栈会慢这么多？？？？！！</p>
<p>话说这题的challenge不会做，他还限制了老师的数量。</p>
<p><a href="http://codeforces.com/problemset/problem/587/D" rel="external nofollow noreferrer">CF 587D</a></p>
<p>这题需要满足的一个东西是，若干的变量里，只能有一个为真或者没有真。假设在x1,x2,...,xn之间只有一个为真。我们可以这样构图：新建点y1,y2,...,yn，加这样一些边xi-&gt;yi+1，yi-&gt;^xi,当然，还有对应的反边^yi+1-&gt;^xi,xi-&gt;^yi。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv1d7jq.html">LruCache算法原理及实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxlkwjq.html">Windows操作系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zvz1d9.html">循环遍历DataTable绑定到Table</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o3kmp8.html">110&period;Balanced Binary Tree  Leetcode解题笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxgw709.html">HTTP头部解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdwepz8.html">12个有趣的C语言面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wzoyxq.html">android 手机信息获取</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd7l1y8.html">android 抽屉式滑动demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vnkxq.html">Web Api集成Swagger</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey41rz9.html">elasticsearch的rest搜索---  安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmwz39.html">keyCode码集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljv60e9.html">【LeetCode】数组-4&lpar;581&rpar;-给未排序数组中子数组排序使得整个数组排序 找到这个最小的子数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7wrj8.html">CAN总线学习记录之四：位定时与同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3r0kq.html">ajax&comma;分页器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvvlkgq.html">使用xshell5 从CentOS主机download资料</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjgnpjq.html">js  Json与对象、数组转化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emxe0e9.html">SpringBoot&lpar;七&rpar;&lowbar;统一异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnlke2q.html">spring 配置定时任务Scheduled</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwle12z9.html">android stuido - 关闭单词拼写检查</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyve74gq.html">js 跨域 之 修改服务器配置-XAMPP-Apache （nginx 拉到最后！）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90m77248.html">转载Spring IntrospectorCleanupListener</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgzzrd8.html">Qt WebKit and HTML5 geolocation &vert; Qt Project forums &vert; Qt Project</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1wdpmq.html">EnumMap源代码阅读器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8memem6q.html">Andorid Binder进程间通信---Binder本地对象，实体对象，引用对象，代理对象的引用计数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjmj1x8.html">Objective-c 数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp0pj39.html">Scala函数---既存类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jd5lv8.html">【ActiveMQ】设置自动重连</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jd57l8.html">javascripts小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zgpon9.html">Java学习03</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jdxdl8.html">条款21： 必须返回对象时，不要强行返回对象的reference</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
